    001/*
    002 * Copyright (c) 2007-2017 Xplenty, Inc. All Rights Reserved.
    003 *
    004 * Project and contact information: http://www.cascading.org/
    005 *
    006 * This file is part of the Cascading project.
    007 *
    008 * Licensed under the Apache License, Version 2.0 (the "License");
    009 * you may not use this file except in compliance with the License.
    010 * You may obtain a copy of the License at
    011 *
    012 *     http://www.apache.org/licenses/LICENSE-2.0
    013 *
    014 * Unless required by applicable law or agreed to in writing, software
    015 * distributed under the License is distributed on an "AS IS" BASIS,
    016 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    017 * See the License for the specific language governing permissions and
    018 * limitations under the License.
    019 */
    020
    021package cascading.operation;
    022
    023import cascading.tuple.Fields;
    024
    025public interface OperationCall<Context>
    026  {
    027  /**
    028   * Returns the user set context object, C.
    029   *
    030   * @return user defined object
    031   */
    032  Context getContext();
    033
    034  /**
    035   * Sets the user defined 'context' object.
    036   *
    037   * @param context user defined object
    038   */
    039  void setContext( Context context );
    040
    041  /**
    042   * Returns the {@link Fields} of the expected arguments {@link cascading.tuple.TupleEntry}.
    043   *
    044   * @return the argumentFields (type Fields) of this OperationCall object.
    045   */
    046  Fields getArgumentFields();
    047  }